import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataAzurestackKeyVaultKeyConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurestack/d/key_vault_key#id DataAzurestackKeyVaultKey#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurestack/d/key_vault_key#key_vault_id DataAzurestackKeyVaultKey#key_vault_id}
    */
    readonly keyVaultId: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurestack/d/key_vault_key#name DataAzurestackKeyVaultKey#name}
    */
    readonly name: string;
    /**
    * timeouts block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurestack/d/key_vault_key#timeouts DataAzurestackKeyVaultKey#timeouts}
    */
    readonly timeouts?: DataAzurestackKeyVaultKeyTimeouts;
}
export interface DataAzurestackKeyVaultKeyTimeouts {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurestack/d/key_vault_key#read DataAzurestackKeyVaultKey#read}
    */
    readonly read?: string;
}
export declare function dataAzurestackKeyVaultKeyTimeoutsToTerraform(struct?: DataAzurestackKeyVaultKeyTimeoutsOutputReference | DataAzurestackKeyVaultKeyTimeouts | cdktf.IResolvable): any;
export declare class DataAzurestackKeyVaultKeyTimeoutsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAzurestackKeyVaultKeyTimeouts | cdktf.IResolvable | undefined;
    set internalValue(value: DataAzurestackKeyVaultKeyTimeouts | cdktf.IResolvable | undefined);
    private _read?;
    get read(): string;
    set read(value: string);
    resetRead(): void;
    get readInput(): string | undefined;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/azurestack/d/key_vault_key azurestack_key_vault_key}
*/
export declare class DataAzurestackKeyVaultKey extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "azurestack_key_vault_key";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/azurestack/d/key_vault_key azurestack_key_vault_key} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataAzurestackKeyVaultKeyConfig
    */
    constructor(scope: Construct, id: string, config: DataAzurestackKeyVaultKeyConfig);
    get e(): string;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    get keyOpts(): string[];
    get keySize(): number;
    get keyType(): string;
    private _keyVaultId?;
    get keyVaultId(): string;
    set keyVaultId(value: string);
    get keyVaultIdInput(): string | undefined;
    get n(): string;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _tags;
    get tags(): cdktf.StringMap;
    get version(): string;
    private _timeouts;
    get timeouts(): DataAzurestackKeyVaultKeyTimeoutsOutputReference;
    putTimeouts(value: DataAzurestackKeyVaultKeyTimeouts): void;
    resetTimeouts(): void;
    get timeoutsInput(): cdktf.IResolvable | DataAzurestackKeyVaultKeyTimeouts | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
